<div class="wrapper">

  <div class="stats-header">
    <div class="stat">
      <a>Memory Bytes: {{getTfMemoryStats().numBytes}}</a>
    </div>
    <div class="stat">
      <a>GPU Memory Bytes: {{getTfMemoryStats().numBytesInGPU}}</a>
    </div>
    <div class="stat">
      <a>Number of Tensors: {{getTfMemoryStats().numTensors}}</a>
    </div>
  </div>

  <!--  <ng-container *ngIf="phase === 'Not Started'">-->
  <ng-container >
    <div class="controls-content">
      <div class="button-container">

        <div class="example-container">
          <form [formGroup]="optionsForm">
            <mat-form-field class="form-field" appearance="fill" floatLabel="always">
              <mat-label>Epochs</mat-label>
              <input matInput placeholder="5" type="number" formControlName="epochs">
            </mat-form-field>

            <mat-form-field class="form-field" appearance="fill" floatLabel="always">
              <mat-label>Batch Size</mat-label>
              <input matInput placeholder="32" type="number" formControlName="batchSize">
            </mat-form-field>
          </form>

        </div>

        <div>
          <label class="example-margin">Backend:</label>
          <mat-radio-group [(ngModel)]="currentBackend">
            <mat-radio-button class="radio-button-class" value="webgl" (click)="changeBackend('webgl')">GPU</mat-radio-button>
            <mat-radio-button class="radio-button-class" value="cpu" (click)="changeBackend('cpu')">CPU</mat-radio-button>
          </mat-radio-group>
        </div>

        <button mat-raised-button [disabled]="(!dataLoaded || phase !== 'Not Started' || uniqueLabels.length === 1) && !errorMessage && !uploadComplete" *ngIf="!modelTrained" color="primary" class="button-class" (click)="trainModel(trainingImages)">Train Model</button>
        <button mat-raised-button [disabled]="!dataLoaded" color="warn" class="button-class" (click)="reset()">Start Over</button>

        <ng-container *ngIf="(uniqueLabels.length === 1) && uploadComplete">
          <div>
            <strong style="color: red">Please supply more than 1 classes for the training dataset!</strong>
          </div>
        </ng-container>

      </div>
    </div>

  </ng-container>

  <ng-container *ngIf="errorMessage">
    <div class="error-container">
      <p class="error-message">{{errorMessage}}</p>
    </div>
  </ng-container>

  <ng-container *ngIf="phase === 'Not Started'">
    <div class="dropper-zone">
      <ngx-file-drop dropZoneLabel="Drop training files here" (onFileDrop)="trainDropped($event)"
                     (onFileOver)="fileOver($event)" (onFileLeave)="fileLeave($event)" >
        <ng-template ngx-file-drop-content-tmp let-openFileSelector="openFileSelector">
          Drop training files here.
<!--          <button type="button" (click)="openFileSelector()">Browse Files</button>-->
        </ng-template>
      </ngx-file-drop>
    </div>
  </ng-container>

  <ng-container *ngIf="(trainingImages.length > 0) && (trainingImages.length < trainingFiles.length)">
    <div class="" style="width: 100%; text-align: center">
      <h4>Uploading images, please wait... {{trainingImages.length}} of {{trainingFiles.length}} uploaded.</h4>
    </div>
  </ng-container>

  <mat-card *ngIf="!modelTrained && processingImage" class="preview-card">
<!--    <mat-card  class="preview-card">-->
    <mat-card-header>
      <mat-card-title>Training Progress
      </mat-card-title>
      <mat-card-subtitle >

      </mat-card-subtitle>

    </mat-card-header>
    <mat-card-content class="preview-card-content">
      <div class="preview-card-image-container">
        <img [src]="processingImage" class="preview-img"/>
      </div>


    </mat-card-content>
    <mat-card-footer>
      <div style="text-align: center">
        <ng-container *ngIf="phase === 'Processing Images'">
          <h4>{{phase}}... {{currentIndex}} out of {{trainingImages.length}}</h4>
        </ng-container>
        <ng-container *ngIf="phase !== 'Processing Images'">
          <h4>{{phase}}...</h4>
        </ng-container>

      </div>
      <div>
        <mat-progress-bar
          color="primary"
          mode="determinate"
          [value]="progressValue">
        </mat-progress-bar>
      </div>

    </mat-card-footer>
  </mat-card>


  <div class="dropper-zone">
    <ngx-file-drop *ngIf="modelTrained" dropZoneLabel="Drop prediction files here" (onFileDrop)="predictDropped($event)"
                   (onFileOver)="fileOver($event)" (onFileLeave)="fileLeave($event)" dropZoneClassName="ngx-file-drop__drop-zone-predict" >
      <ng-template ngx-file-drop-content-tmp let-openFileSelector="openFileSelector">
        <a style="color: #cf9607;">Drop an image file to get a prediction.</a>
<!--        <button type="button" (click)="openFileSelector()">Browse Files</button>-->
      </ng-template>
    </ngx-file-drop>
  </div>

  <mat-card *ngIf="modelTrained && validationFiles.length > 0" class="prediction-card">
    <mat-card-header>
      <mat-card-title>Prediction Result
      </mat-card-title>
      <mat-card-subtitle >

      </mat-card-subtitle>

    </mat-card-header>
    <mat-card-content class="prediction-card-content">
      <div class="validation-results-container">
        <div>
          <h2>Prediction: {{predictionLabels[0]?.toUpperCase()}}</h2>
        </div>
      </div>
      <div class="validation-image-container">
        <img [src]="validationImgUrls[0]"  class="prediction-img"/>
      </div>
      <div class="validation-results-container">

      </div>


    </mat-card-content>
    <mat-card-footer>

    </mat-card-footer>
  </mat-card>

  <mat-card *ngIf="trainingImages.length > 0" class="training-dataset-card">
    <mat-card-header>
      <mat-card-title>
        Training Dataset
      </mat-card-title>
      <mat-card-subtitle>
        Click on the class panels below to view associated training images... <a style="color: white">{{trainingImages.length}} training images in {{uniqueLabels.length}} classes</a>
      </mat-card-subtitle>
    </mat-card-header>
    <mat-card-content class="training-set-preview" >
<!--      <div style="width: 100%">{{trainingImages.length}} training images in {{uniqueLabels.length}} classes</div>-->
      <ng-container *ngIf="getUnknownClasses(labelObject).length > 0">
        <div style="width: 100%; text-align: left; margin-bottom: 1em"><strong style="color: red">There {{(getUnknownClasses(labelObject).length > 1 ) ? 'are' : 'is'}} {{getUnknownClasses(labelObject).length}} unknown {{(getUnknownClasses(labelObject).length > 1 ) ? 'classes' : 'class'}}. You can rename unknown classes using the fields below.</strong></div>
        <div style="width: 100%; display: flex; justify-content: flex-start; flex-wrap: wrap">
          <ng-container *ngFor="let unknownClass of getUnknownClasses(labelObject); let i=index">
            <div>
              <mat-form-field class="form-field" appearance="fill" floatLabel="always">
                <mat-label>{{unknownClass}}</mat-label>
                <input #input matInput [placeholder]="unknownClass">
              </mat-form-field>
              <button mat-raised-button color="accent" style="align-self: center" (click)="setClass(getUnknownClasses(labelObject)[i], input.value)">Set Class</button>
            </div>
          </ng-container>
        </div>

      </ng-container>
      <ng-container *ngFor="let label of uniqueLabels">
        <div class="class-expansion-panel">
          <mat-expansion-panel >
            <mat-expansion-panel-header>
              <mat-panel-title>
                {{label.toUpperCase()}}
              </mat-panel-title>
              <mat-panel-description>
                {{getClassItems(trainingImages, label).length}} items
              </mat-panel-description>
            </mat-expansion-panel-header>
            <div class="class-expansion-panel-body">
              <ng-container *ngFor="let item of (getClassItems(trainingImages, label)); let i=index">
                <div class="training-item-container">
                  <div class="training-item-img-container">
                    <img [src]="item.image" class="training-img"/>
                  </div>
                  <!--                <div class="training-item-name-container">
                                    <strong class="training-container-font">Class: {{ item.class }}</strong>
                                  </div>-->
                  <div class="training-item-name-container">
                    <strong class="training-container-font">{{ item.name }}</strong>
                  </div>
                </div>
              </ng-container>
            </div>

          </mat-expansion-panel>
        </div>

      </ng-container>
    </mat-card-content>


  </mat-card>


</div>
